/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __platform_envvar_h__
#define __platform_envvar_h__

#if FE_COMPILER==FE_GNU

// __builtin_prefetch(ADDR,WRITE 0-1,LOCALITY 0-3)
#define FEPREFETCH_READ(address)	__builtin_prefetch(address,0,0)
#define FEPREFETCH_WRITE(address)	__builtin_prefetch(address,1,0)
#define FE_PREFETCHING				TRUE

#else

#define FEPREFETCH_READ(address)
#define FEPREFETCH_WRITE(address)
#define FE_PREFETCHING				FALSE

#endif

namespace fe
{

/**************************************************************************//**
	@brief System call wrappers

	@ingroup platform
*//***************************************************************************/
class FE_DL_PUBLIC System
{
	public:
				System(void);

static	bool	getEnvironmentVariable(const String &name, String &value);
static	bool	setCurrentWorkingDirectory(const String &a_path);
static	bool	createDirectory(const String &a_path);
};

} /* namespace */

#endif /* __platform_envvar_h__ */

